      program funpar0
c*********************************************************************
c* programa que lee parametros del modelo y 
c* hace que la  subrutina diagon escriba en el archivo
c*  eva00.dat, los eigenvalores del Hamiltoniano:
c* 2\epsilon S_0 + \omega_b b^\dagger b 
c*        + V_1( vp*(S+^2 b  + S-^2 b^t) +
c*               vs*2*S-S-(b + b^t)      +
c*               vv*(S+^2 b^t  + S-^2 b)  )
c* (o modelos bosonicos),
c* para todos los valores del seudoespin
c*     J=omega,omega-1/2,omega-1,...,1/2,0.
c*
c* El archivo eva00.dat (y vae00.dat en el caso que se
c*  quieran valores de expectacion)    es leido despues por funpar1.f
c*  para calcular la funcion de particion y Trazas <O>.
c*
c*10 junio  2002 Sergio Lerma
c*********************************************************************
      real epsilon,omegab,v1,e0,vp,vs,vv
      integer omega,ngmax
      integer nx,nrootx,njx,ndj,nev,ned
      common /parametros/epsilon,omegab,v1,e0
      common /topes/omega,ngmin,ngmax,ndj
c Archivos de entrada y salida
      open(unit=1,file="funpar.in") !archivo de entrada
      open(unit=2,file="eva00.dat") !Archivo para eigenvalores
      open(unit=3,file="vae00.dat") !Archivo para valores de expec.
      read(1,*) !epsilon,omegab,v1
      read(1,*) epsilon,omegab,v1
      read(1,*) !omega
      read(1,*) omega
      read(1,*) !numero maximo de gluones
      read(1,*) ngmax
      read(1,*) ! usar todas los eigenvalores (0) o solo nrootx (1)
      read(1,*) nte
      read(1,*) !nrootx
      read(1,*) nrootx
      read(1,*) !1 calcular valores de expec, otro no calcular
      read(1,*) nev
      read(1,*) !1 mod bos, 2 mod bos con corte, cualq otro exacto.
      read(1,*) ned       
      read(1,*) !Pesos de los terminos de interaccion
c               !Pair creation,Scattering,Vacuum corelations
      read(1,*) vp,vs,vv
      ngmin=0
c loop para todos los pseudoespines ndJ
      write(*,*) "Avance:"
      do ndj=2*omega,0,-1
       write(*,*)  int(100.0*(2*omega-ndj+1)/(2*omega +1)),"%"
c Paridad positiva
       if (ndj.eq.2*(ndj/2)) then  !si J es entero
          njx=(ndj/2)+1
       else                        ! si J es semientero
          njx=(ndj+1)/2
       end if
       njx=njx*(ngmax+1) ! tamanio de la matriz
       nrootx=min(nrootx,njx)
       if (nte.ne.1) nrootx=njx
       CALL  diagon (njx,2*omega,nrootx,0,ned,nev,2,3,1,vp,vs,vv)
c Paridad negativa 
       if (ndj.eq.2*(ndj/2)) then  !si J es entero
          njx=(ndj/2)
       else                        ! si J es semientero
          njx=(ndj+1)/2
       end if
       njx=njx*(ngmax+1)           ! tamanio de la matriz
       nrootx=min(nrootx,njx)
       if (nte.ne.1) nrootx=njx
       CALL  diagon (njx,2*omega,nrootx,2,ned,nev,2,3,1,vp,vs,vv)
      end do
      stop 
      end


