      subroutine U6s(h1,h2,h3,h4,h5,h6,
     &           hu21,hu22,    ! SU(2)
     &           hu31,hu32,hu33, !SU(3)
     &           mult,nr,maxr)   ! multiplicidad

c*********************************************************************
c*            PROGRAMA PARA REDUCIR IRREP DE U(6) A IRREPS
C*                 DE U(3) X U(2)
c* EN ESTE PROGRMA CAMBIO EL ORDEN DE LAS VARIABLES-MATRIZ
C* y modifico la salida a 2 hfro4 y hfro3
C*           VARIABLES DE ENTRADA:
C*               h(6) - RENGLONES DEL IRREP U(6)
C*           VARIABLES DE SALIDA:
C*               NRD - NUMERO DE DESCOMPOSICIONES U3XU4 DIFERENTES
C*               NRDMAX4 - NUMERO MAXIMO DE DESC DIFERENTES
C*               NRDMAX3 - (PARA DIMENSIONAR A PRIORI)
C*               HFRO4(4,NRDMAX4) y HFRO3(4,NRDMAX3):
C*               HFRO3(1-3) - RENGLONES DE U3 DEL TERMINO I DE LA
C*                           DESCOMPOSICION
C*               HFRO(0-NRD,4-7) - RENGLONES DE U4 DEL TERMINO I DE LA
C*                           DESCOMPOSICION
C*               HFRO(0-NRD,8)   - MULTIPLICIDAD DEL TERMINO I
C*
C*   ultima modificacion: 30 ago 2001
C*  autor Sergio Lerma
C***************************************************************************
     
      INTEGER h(6)
      integer h1,h2,h3,h4,h5,h6
      integer hu21(maxr),hu22(maxr), hu31(maxr),hu32(maxr),hu33(maxr)
      integer mult(maxr),nr

      integer NDD


c*******NUEVO
      INTEGER NROMAX2
      PARAMETER (NROMAX2=60)
      integer HFU4RO(4,NROMAX2),HFU3RO(3,NROMAX2,NROMAX2)
      integer FRO(NROMAX2,NROMAX2),JRO(NROMAX2),NFRO  
     
C----FUNCION
      INTEGER NSRTS
    
C----INICIALIZACION DE VARIABLES
c      DATA HFU4RO /80*0/
c      DATA HFU3RO /1200*0/
c      DATA FRO /400*5/
c      DATA JRO /20*0/
c       OPEN (UNIT=16,FILE='u6.out')
        lc=lc+1
c       WRITE(*,*) lc," veces en la reduccion" 
       do nk=1,nromax2
          do nk2=1,nromax2
             hfu3ro(1,nk2,nk)=0
             hfu3ro(2,nk2,nk)=0
             hfu3ro(3,nk2,nk)=0
             fro(nk2,nk)=0
          end do
          hfu4ro(1,nk)=0
          hfu4ro(2,nk)=0
          hfu4ro(3,nk)=0
          hfu4ro(4,nk)=0
          jro(nk)=0
       end do   
            

       NFRO=0
       h(1)=h1
       h(2)=h2
       h(3)=h3
       h(4)=h4
       h(5)=h5
       h(6)=h6
       nr=0
       do ma=1,maxr
          hu21(ma)=0
          hu22(ma)=0
          hu31(ma)=0
          hu32(ma)=0
          hu33(ma)=0
          mult(ma)=0
       end do   
C------------------------------------------------------------
C               INPUT
        
c        write(*,*) "Introduzca los renglones de U(12)"
c        write(*,*) "(maximo 6 por el momento)" 
c        READ (*,*) h
c        write(*,*)"Ahi voy"
c       DO NMM=1,6
c          h(NMM)=6
c       END DO
C------------------------------------------------------------
c        llama a subrutina principal

         CALL REDU (h,HFU4RO,HFU3RO,FRO,JRO,NFRO,NROMAX2)

C-------------------------------------------------------------------
C         SALIDA 


      NDD=0

       DO L=1,NFRO
         DO LL=1,JRO(L)
          IF (FRO(LL,L).NE.0) NDD=NDD+1
         END DO 
       END DO  

c      write(16,*)
c      write(16,*)
c      WRITE(16,*) "DESCOMPOSICION DEL"
c      WRITE(16,*) "IRREP DE U(6): [",h," ]"
c      WRITE(16,*) "  EN IRREPS DE U(2)XU(3) "
c      write(16,*)
c      WRITE(16,*) "No.DE IRREPS DIFERENTES EN LA DESC. : ",NDD   
c      write(16,*)
c      write(16,*)
c      WRITE(16,*) "  U(2)        X        U(3)     multiplicidad"
c      write(16,*)
      nk=0
      ndim2=0
      
      DO L=1,NFRO
         DO LL=1,JRO(L)
          IF (FRO(LL,L).NE.0) THEN
c          WRITE(16,*) "[",HFU4RO(1,L)," ",HFU4RO(2,L),
c    &           " ]    X   [", HFU3RO(1,LL,L)," ",HFU3RO(2,LL,L)," ",
c    &           HFU3RO(3,LL,L),"]    ", FRO(LL,L)
           nk=nk+1
           if(nk.gt.maxr) then
             write(*,*) "Numero de irreps mayor que maxr, cambiarla!!!"
             
             stop
           end if   
c           write(*,*) "al final es  ",FRO(1,1) 
           hu21(nk)=HFU4RO(1,L)
           hu22(nk)=HFU4RO(2,L)
           hu31(nk)=HFU3RO(1,LL,L)
           hu32(nk)=HFU3RO(2,LL,L)
           hu33(nk)=HFU3RO(3,LL,L)
           mult(nk)=FRO(LL,L)
           ndim2=ndim2+mult(nk)*0.5*(hu21(nk)-hu22(nk)+1)*
     &      (hu31(nk)-hu32(nk)+1)*(hu32(nk)-hu33(nk)+1)*
     &      (hu31(nk)-hu33(nk)+2) 
          END IF 
         END DO 
      END DO
      nr=nk

c**************Check DIM*********************
      ndim1=( (h1-h2+1)*(h1-h3+2)*(h1-h4+3)*(h1-h5+4)*(h1-h6+5)
     &*(h2-h3+1)*(h2-h4+2)*(h2-h5+3)*(h2-h6+4)*(h3-h4+1)*(h3-h5+2)
     &*(h3-h6+3)*(h4-h5+1)*(h4-h6+2)*(h5-h6+1) )
     &  / (5*4*3*2*4*3*2*3*2*2)
      
      if(ndim1.ne.ndim2) then
         write(*,*)" ERROR, LAS DIMENSIONES NO COINCIDEN!!!!"
         write(*,*) "dimension U(6) ",ndim1,"  dimension de la",
     & "reduccion ",ndim2

c        write(16,*)"LAS DIMENSIONES NO CHECAN"
c        write(16,*) "dimension U(6) ",ndim1,"  dimension de la",
c     & "reduccion ",ndim2
        stop
      else
c         write(16,*) "DIMENSION DE LA REDUCCION CORRECTA: ",ndim2
      end if  
C-------------------------------------------------------------------      
      
      END

C-------------------------------------------------------------------
C-------------------------------------------------------------------


      SUBROUTINE REDU  (h,HFU4RO,HFU3RO,FRO,JRO,NFRO,NROMAX2)
C*********REDU*****************************************************
C*   SUBRUTINA PRINCIPAL:                                         *
C*              llama a las diferentes subritinas y
c*      ALMACENA Y CUENTA LA MULTIPLICIDAD DE LOS IRREPS que
c*       van apareciendo                                          *
C*                EN LA DESCOMPOSICION                            *
C*                                                                *
C*   SUBRUTINA LLAMADA POR EL PROGRMA PRINCIPAL                   *
C*   LLAMA A:  DESC - DESCOMPONE EL IRREP U(12) EN IRREPS TOT.SIM *
C*             RTSS - REDUCE CADA UNO DE LOS 6 IRREP TOT SIM DE   *
C*                   DESC EN IRREPS DE U(3)XU(4)                  *
C*             MULTDY-MULTIPLICA LOS IRREPS U(3)XU(4) DE RTSS     *
C*                                                                *
c******************************************************************

C variable que entra de principal
       INTEGER h(6)         
c variable que regresa a principal
       INTEGER NROMAX2
       integer HFU4RO(4,NROMAX2),HFU3RO(3,NROMAX2,NROMAX2)
       integer FRO(NROMAX2,NROMAX2),JRO(NROMAX2),NFRO

     
C----------------------------------

c variables que van y regresan de subrutina DESC

C   NUMERO MAXIMO DE DESCOMPOSICIONES DIFERENTES EN IRREPS TOT.SIM. 

        INTEGER MAXDESDIF
        PARAMETER(MAXDESDIF=10000)

        INTEGER NDESD,NM(MAXDESDIF), FDES(6,MAXDESDIF)
C-----------------------------------


C-funciones
        INTEGER D3,D2
        INTEGER NSRTS
c-

c variables que regresan de subrutina RTSS y MULTDY

        INTEGER NSRTMAX
        PARAMETER (NSRTMAX=1000)
        INTEGER CC(6),RTS(3,NSRTMAX,6)



C***NUEVO
        INTEGER NRMAX2
        PARAMETER (NRMAX2=60)
        integer HFU4R(4,NRMAX2),HFU3R(3,NRMAX2,NRMAX2)
        integer FR(NRMAX2,NRMAX2),JR(NRMAX2),NFR


C------------MISCELANEAS
      INTEGER VER,K,NRD

C-----INICIALIZACION DE VARIABLES
      nfr=0
      do nj1=1,nrmax2
         do nj2=1,nrmax2
           hfu3r(1,nj2,nj1)=0
           hfu3r(2,nj2,nj1)=0
           hfu3r(3,nj2,nj1)=0
           fr(nj2,nj1)=0
         end do
         hfu4r(1,nj1)=0
         hfu4r(2,nj1)=0
         hfu4r(3,nj1)=0
         hfu4r(4,nj1)=0
         jr(nj1)=0
       end do  
       DO L=1,6
        CC(L)=0  
        DO M=1,NSRTMAX
         DO N=1,3          
          RTS(N,M,L)=0
         END DO
        END DO
       END DO  
       NRD=0
       NFR=0
C-----------------------------------------------
       
         CALL DESC (h,FDES,NM,NDESD,MAXDESDIF)
         
       DO NET=1,NDESD
c           write(*,*) NET," de ",NDESD
           IF (NM(NET).eq.0) go to 10
           DO L=1,6
            CC(L)=FDES(L,NET)
           END DO
         
           CALL RTSS (CC,RTS,NSRTMAX)
           
C llama a subritina que   MULTIPLICA (KROENECKER) LA REDUCCION DE LA
C ---------------- DESCOMPOSICION TOT. SIM.
c esta subrutina realiza el trabajo que hace lento al programa
c optimizarla.... 
         
       
       CALL MULTDY (RTS,CC,HFU4R,HFU3R,FR,JR,NFR,NSRTMAX,NRMAX2)

c el siguiente loop tarda optimizarlo (OPTIMIZADO!!!)
         
           DO  L=1,NFR
            VER=0
            K=0
             DO WHILE(VER.NE.4 .AND. K.NE.NRD)
              VER=0
              K=K+1
                DO M=1,2
                IF ((HFU4R(M,L).NE.HFU4RO(M,K)).OR.(HFU4R(M+2,L).NE.HF
     &U4RO(M+2,K))) go to 17
                 VER=VER+2
                END DO
 17             continue
             END DO
            IF (VER.EQ.4) THEN
               DO Q1=1,JR(L)
                  V1=0
                  Q2=0
                  DO WHILE (V1.NE.3.AND.Q2.NE.JRO(K))
                     V1=0
                     Q2=Q2+1
                     DO Q3=1,3
                     IF (HFU3R(Q3,Q1,L).NE.HFU3RO(Q3,Q2,K))GO TO 88
                     V1=V1+1
                     END DO
 88                  CONTINUE
                  END DO
                  IF (V1.EQ.3) THEN
                     FRO(Q2,K)=FRO(Q2,K)+NM(NET)*FR(Q1,L)
                  ELSE 
                     JRO(K)=JRO(K)+1
                     DO MMM=1,3
                      HFU3RO(MMM,JRO(K),K)=HFU3R(MMM,Q1,L)
                     END DO
                     FRO(JRO(K),K)=NM(NET)*FR(Q1,L)
                  END IF   
               END DO
   
C               HFRO(8,K)=HFRO(8,K)+NM(NET)*HFR(8,L)


            ELSE
             NFRO=NFRO+1
              DO Q=1,4
               HFU4RO(Q,NFRO)=HFU4R(Q,L)
              END DO
              JRO(NFRO)=JR(L)
              DO Q=1,JR(L)
                 FRO(Q,NFRO)=NM(NET)*FR(Q,L)
                 DO QQ=1,3
                    HFU3RO(QQ,Q,NFRO)=HFU3R(QQ,Q,L)
                 END DO   
              END DO
   
C             HFRO(8,NRD)=NM(NET)*HFR(8,L)
            END IF
           END DO
           NRD=NFRO
 10        continue

       END DO



C SALIDA   HFU4R0,HFU3RO,FRO,JRO Y NFRO

C FIN DE SUBRUTINA REDU
      END

C-----------------------------------------------------------------



      SUBROUTINE   DESC (h,FDES,N,NDESD,MAXDESDIF)
c    SE TIENE UNA SUBRUTINA MEJOR sustituirla despues...

c*******************************************************************
c*  subprogrma para DESCOMPONER EN IRREPS TOTALMENTE SIMETRICOS    *
c*       DE U(12) un irrEP DADO DE U(12)                           *      
c*                                                                 *
c*       VARIABLES DE ENTRADA:                                     *
c*         hD(i) - numero de cuadros en renglon i del irrep de U(12)*     
c*       VARIABLES DE SALIDA:                                      *
c*         NDESD - numero de descomposiciones diferentes.          *
c*         FDES(i,ni) - numero de cuadros del i esimo factor de la *
c*                     ni esima descomposicion.                    *
c*         N(ni)  - factor  de la ni-esima descomposicion    *
c*                                                                 *
c*                                                                 *
c*                                                                 *
c*******************************************************************


C------------------------------------------------------
C      DECLARACION DE VARIABLES


        INTEGER hD(6),h(6)     




         INTEGER  N(MAXDESDIF),FDES(6,MAXDESDIF),NDESD


C   RDE-ROTULO DE LA DESCOMPOSICION, C(i)-FACTORES TEMPORALES DE
C    LA DESCOMPOSICION
 

        INTEGER  RDE,C(6) 

        INTEGER  K(5,2:6),SGN
        INTEGER VERDAD

C------------------------------------------------------------

C------------------------------------------------------------
C               INPUT (YA ESTA DADO)
        
C        write(*,*) "Introduzca los renglones de U(12)"
C        write(*,*) "(maximo 6 por el momento)" 
C        READ *, h


C----------------------------------------------------------
C               INICIALIZACION DE VARIABLES

        DO C1=1,6
           C(C1)=0
           hD(C1)=h(C1)
        END DO
        DO L=1,MAXDESDIF
          N(L)=0
          DO L2=1,6
           FDES(L2,L)=0
          END DO
        END DO
        SGN=1
        NDESD=0


C------------------------------------------------------------
c     IMPLEMENTACION DE LOS LOOPS ANIDADOS PARA LA MULTIPLICACION
C !!!!!se tiene  un metodo sin tanto loops y mas directo...        
        
             
       DO   K12=1,2
        K(1,2)=K12

  
       DO   K13=1,2
        K(1,3)=K13

       DO   K14=1,2
        K(1,4)=K14

     
            
       DO   K15=1,2
        K(1,5)=K15

       DO   K16=1,2
        K(1,6)=K16

         
       DO   K23=1,2
        K(2,3)=K23

       DO   K24=1,2
        K(2,4)=K24

        
       DO   K25=1,2
        K(2,5)=K25

     
       DO   K26=1,2
        K(2,6)=K26

       DO   K34=1,2
        K(3,4)=K34

       DO   K35=1,2
        K(3,5)=K35

       DO   K36=1,2
        K(3,6)=K36

       DO   K45=1,2
        K(4,5)=K45

               
       DO   K46=1,2
        K(4,6)=K46

            
       DO   K56=1,2
        K(5,6)=K56

c------------------------------------------------------------

c     ASIGNA LOS VALORES TEMPORALES C


      DO L=1,5
         DO M=L+1,6
            IF (K(L,M).EQ.2) THEN
               C(L)=C(L)+1
               C(M)=C(M)-1
               SGN=-1*SGN
            END IF
         END DO
      END DO

C----------------------------------------------------------
C    VERIFICA QUE SE TIENE UN DESCOMPOSICION VALIDA SI ES ASI
C    LLAMA A SUBRUTINA PARA VER SI LA DESCOMPOSICION ES NUEVA O
c   YA EXISTIA Y CUENTA CUANTAS VAN
C-------------------------------------------------------

         VERDAD=0
  
      IF ( (h(1)+C(1)).GE.0 .AND. (h(2)+C(2)).GE.0 ) VERDAD=VERDAD+1
      IF ( (h(3)+C(3)).GE.0 .AND. (h(4)+C(4)).GE.0 ) VERDAD=VERDAD+1
      IF ( (h(5)+C(5)).GE.0 .AND. (h(6)+C(6)).GE.0 ) VERDAD=VERDAD+1


      IF (VERDAD .EQ. 3) THEN
                CALL CHECAR (hD,FDES,MAXDESDIF,NDESD,RDE,C)
      ELSE
       GO TO 100 
      END IF 


        

C------------CONTADOR DE DESCOMPOSICIONES DEL TIPO RDE

        N(RDE)=N(RDE)+SGN

100     DO L=1,6
         C(L) =0
         hD(L)=h(L)      
         END DO
        SGN=1


C---------------------------------------------------------------------
C     CIERRE DE LOS LOOPS ANIDADOS
      
       END DO
       END DO 
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO
       END DO       
 


C-------------------------------------------------------------------
C         SALIDA  si O NO !!!!!!!
 


c      OPEN (UNIT=16,FILE='u12f.out')
          
c      WRITE(16,*) "Descomposicion  en productos de irreps de U(12)"
c      write(16,*)  "totalmente simetricos."
c      write(16,*) "Numero de sumandos DIFERENTES: ",NDESD   
c      write(16,*)    
c      DO L=1,NDESD
c      WRITE(16,*) FDES(1,L),FDES(2,L),FDES(3,L),FDES(4,L),FDES(
c     &5,L),FDES(6,L),"  con factor    " , N(L)
 
c      END DO
      
C   FIN DE SUBRUTINA DESC       
      END

C-------------------------------------------------------------------------

 


        SUBROUTINE CHECAR (h,FDES,MAXDESDIF,NDESD,RDE,C)

C      ***************************************************************
C      *     SUBROUTINA DE SUBRUTINA DESC que CHECA SI UNA           *
C      *        DESCOMPOSICION TOT. SIM. YA EXISTE                   *
C      *                                                             *
C      ***************************************************************


C----------DECLARACION DE VARIABLES


        INTEGER K,KC,KC2,L, RDE,NDESD,h(6), C(6), FDES(6,MAXDESDIF)
        INTEGER NTEM1,NTEM2,VER

C---------ORDENA LOS FACTORES DE MAYOR A MENOR


       DO   KC=1,5
          DO  KC2=KC+1,6
                IF (h(KC)+C(KC).LT.h(KC2)+C(KC2)) THEN
                             NTEM1=h(KC)
                             NTEM2=C(KC)
                             C(KC)=C(KC2)
                             h(KC)=h(KC2)
                             C(KC2)=NTEM2
                             h(KC2)=NTEM1
                END IF
          END DO
       END DO                

C--------CHECA SI LA FACTORIZACION YA EXISTE,SI NO LA GUARDA. REGRESA.
           
       VER=0     
       K=0          
       DO  WHILE (VER.NE.6 .AND. K.NE. NDESD)
        VER=0
        K=K+1
        DO  L=1,6
                IF (h(L)+C(L).ne. FDES(L,K)) go to 22
                VER=VER+1      
        END DO
 22     continue
       END DO

        IF (VER.EQ.6) THEN
             RDE=K
        ELSE
           NDESD=NDESD+1
           RDE=NDESD          
           DO L=1,6 
              FDES(L,RDE)=h(L)+C(L)
           END DO   
        END IF
C- FIN DE SUBSUBRUTINA CHECAR       
      END
                   
C-------------------------------


C-------------------------------
C-------------------------------

      SUBROUTINE RTSS (CC,RTS,NSRTMAX)
C********************************************************************
C*            SUBRUTINA QUE DESCOMPONE 6 IRREPS TOT SIM DE U(12)    *
C*              EN IRREPS DE U(3)XU(2)                              *
C*                                                                  *
C*         ENTRADA: CC(6)  (CUADROS DE LOS 6 IRREPS TOT SIM DE U(12)*
C*         SALIDA: RTS(K,N,6) N-ESIMA DESCOMPOSICION DE CADA UNO DE *
C*                 LOS 6 IRREPS DE U(12), EN IRREPS DE U(3) (K=1,3) *
c*                 Y U(4) (K=3,7).(los irreps de U(3) y U(4) son los*
c*                 mismos pero se hace asi para posterior uso.)     *
c*                                                                  *
c*         SUBRUTINA LLAMADA POR: REDU                              *
c********************************************************************
       
C--------DECLARACION DE VARIABLES
      
C     INTEGER NSRTMAX
      INTEGER CC(6),K,RTS(3,NSRTMAX,6)
C FUNCIONES
      INTEGER D2,D3,NSRTS

C------- INICIALIZACION DE VARIABLES
      DO L=1,6
       DO M=1,NSRTMAX
        DO N=1,3
         RTS(N,M,L)=0
        END DO  
       END DO
      END DO
C------------

       DO L=1,6
          K=0
          do n1=(cc(L)+1)/2,cc(L)
             k=k+1
             rts(1,k,L)=n1
             rts(2,k,L)=cc(L)-n1
             rts(3,k,L)=0
          end do   
       END DO


C--------FIN DE SUBRUTINA RTSS
      END

       SUBROUTINE MULTDY (RTS,CC,HFU4R,HFU3R,FR,JR,NFR,NSRTMAX,NRMAX2) 
C**********************************************************************
C*     SUBRUTINA QUE MULTIPLICA (KROENECKER) AL NIVEL U(3)XU(4)       *
C*         LOS 6 IRREPS TOT. SIM DE U(12).                            *
C*        NUeva subrutina myultdy que colecta en cada paso los
c*         irreps iguales de U(4) para multiplicarlos una vez. 
c*        algoritmo (1X2)X3... con colecta de U4's sin falla
C*         
C*       VARIABLES DE ENTRADA:                                        *
C*             RTS(3,N,6) - LAS REDUCCIONES DE CADA UNO DE LOS 6      *
C*                            DIAGRAMAS TOT SIM DE U(12) A U(3)       *
C*                             U(4) (K=1,3 Y K=4,7), N ROTULA A       *
C*                           LAS DIFERENTES REDUCCIONES               *
C*               CC(6) - No.  CUADROS  DE LOS 6 IRREP TOT SIM DE U(12)*
C*             NRMAX   - NUMERO MAXIMO DE IRREPS U3XU4, INTRODUCIDO   *
C*                       PARA DIMENSIONAR A PRIORI                    *
C*       VARIABLES DE SALIDA:                                         *
C*                                                                    *
C*              - IRREPS U(3)XU(4) DE LA MULTIPLICACION  *
C*                             DE KROENECKER, EN ESTE ARREGLO SE      *
C*                             PUEDEN REPETIR IRREPS, EN REDU SE      *
C*                             ENCUENTRA LA MULTIPLICIDAD Y CUANTOS   *
C*                             DIFERENTES HAY.                        *
C*                         - EL NUMERO TOTAL DE IRREPS QUE RESULTAN*
C*                              CON CONSIDERAR QUE HAY IRREPS IGUALES.*
C*                    estas variables  internas  han cambiado         *
C*         VARIABLES INTERNAS: HF1(NRMAX,7),NF1,HF2(NRMAX,7),NF2     
C*                       FI1(7),FI2(7)      
C*         SUBRUTINA LLAMADA POR:   REDU                              *
C*         SUBRUTINA QUE LLAMA A:   PDY3 , PDY4                       *
C*                                                                    *
C*   ultima modificacion:23 ago 01
C**********************************************************************

C----DECLARACION DE VARIABLES

        integer nsrtmax,nrmax2
        INTEGER CC(6),RTS(3,NSRTMAX,6)



C  variables  internas (YA NO SON INTERNAS LAS R'S)

        INTEGER HFU41(4,NRMAX2),HFU4R(4,NRMAX2)
        INTEGER HFU31(3,NRMAX2,NRMAX2),HFU3R(3,NRMAX2,NRMAX2)
        INTEGER HFU42(4,NSRTMAX),HFU32(3,NSRTMAX)
        integer HFU3A(3,NRMAX2),FA(NRMAX2),JA
        
        INTEGER F1(NRMAX2,NRMAX2),FR(NRMAX2,NRMAX2)
        INTEGER J1(NRMAX2),JR(NRMAX2),NF1,NF2,NFR
        integer XN,x,y,z

        
        INTEGER h3(3),h3T(3),h4(4),h4T(4)

        INTEGER NDY3MAX
        INTEGER NDY4MAX
        PARAMETER (NDY3MAX=2000)
        PARAMETER (NDY4MAX=50000)
        INTEGER HR3(3,NDY3MAX),NDY3,HR4(4,NDY4MAX),NDY4

C----FUNCIONES
        INTEGER D3,D2
        INTEGER NSRTS
        
        integer PRUEBA,K,VERDAD

        

C------INICIALIZACION DE VARIABLES


      
      

C---------PRIMER FACTOR
      NF1=NSRTS(CC(1))
      DO M=1,NF1
         DO K1=1,3
          HFU41(K1,M)=RTS(K1,M,1)
          HFU31(K1,1,M)=RTS(K1,M,1)
         END DO
         HFU41(4,M)=0
         J1(M)=1
         F1(1,M)=1
      END DO
      



C INICIO DEL LOOP PRINCIPAL 
C MULTIPLICACION DE 1X2 LUEGO (1X2)X3 ETC.
c!!!!!!!!!!!!!!
C ESTE ES EL LOOP QUE RETARDA MUCHISIMO EL PROGRAMA...
c!!!!!!!!!!!!!!!!
C--------------------------------------------------


      DO L=2,6

C INICIALIZAR LAS CANTIDADES R
         
       DO L1=1,NFR 
        JR(L1)=0
       END DO

       NFR=0
      

C ------- PREPARACION DEL 2o FACTOR
      
        NF2=NSRTS(CC(L))
        DO IN=1,NF2
         DO IP=1,3
           HFU32(IP,IN)=RTS(IP,IN,L)
           HFU42(IP,IN)=RTS(IP,IN,L)
         END DO
           HFU42(4,IN)=0
        END DO
C--------------------
        


c         WRITE(*,*) "A MULTIPLICAR ",NF1," FACTORES DIFERENTES"


c         WRITE(*,*) "CON  ",NF2," FACTORES DIFERENTES"

C--------MULTIPLICACION  DE 2 FACTORES

       
       DO X=1,NF1
        DO Y=1,NF2

c puesta a cero de las cantidades A's
           JA=0
                   
           DO Z=1,J1(X)
              DO M=1,3
               H3(M)=HFU31(M,Z,X)
               H3T(M)=HFU32(M,Y)
              END DO

              CALL PDY3(H3,H3T,HR3,NDY3,NDY3MAX)

              DO CON2=1,NDY3
               K=0
               VERDAD=0
               DO WHILE (VERDAD.NE.3 .AND. K.NE. JA)
                VERDAD=0
                K=K+1
                DO M=1,3
                 IF (HR3(M,CON2).ne.HFU3A(M,K)) go to 62
                 VERDAD=VERDAD+1
                END DO
 62             continue
               END DO

               IF (VERDAD.EQ.3) THEN
                FA(K)=FA(K)+F1(Z,X)
               ELSE
                JA=JA+1
                FA(JA)=F1(Z,X)
                DO M=1,3
                 HFU3A(M,JA)=HR3(M,CON2)
                END DO
               END IF
              END DO

           END DO
 
         DO IM=1,4
           h4(IM)=HFU41(IM,X)
           h4T(IM)=HFU42(IM,Y) 
         END DO
 
         CALL PDY4 (h4,h4T,HR4,NDY4,NDY4MAX)

         DO CON=1,NDY4
            
            K=0
            VERDAD=0
            DO WHILE (VERDAD.NE.4 .AND. K.NE.NFR)
                  K=K+1
                  VERDAD=0
                  DO M=1,4
                   IF (HFU4R(M,K).ne.HR4(M,CON)) go to 66
                   VERDAD=VERDAD+1
                  END DO
 66               continue
            END DO

            IF (VERDAD.EQ.4) THEN
               XN=K
            ELSE
               NFR=NFR+1
               XN=NFR
               DO M=1,4
                  HFU4R(M,NFR)=HR4(M,CON)
               END DO
            END IF

C---"CONTRACCION" (i.e. verifica el resultado nuevo con lo que ya se tenia)    

           DO MN=1,JA
            K=0
            VERDAD=0
            DO WHILE(VERDAD.NE.3 .AND. K.NE.JR(XN))
               VERDAD=0
               K=K+1
               DO M=1,3
                IF (HFU3A(M,MN).ne.HFU3R(M,K,XN)) go to 68
                VERDAD=VERDAD+1
               END DO
 68            continue
            END DO
            IF (VERDAD.EQ.3) THEN
             FR(K,XN)=FR(K,XN)+FA(MN)
            ELSE
             JR(XN)=JR(XN)+1
             FR(JR(XN),XN)=FA(MN)
             DO M=1,3
                HFU3R(M,JR(XN),XN)=HFU3A(M,MN)
             END DO
            END IF   
           END DO


         END DO
         
 
        END DO

       END DO


c---------RECUPERA RESULTADO PARA OPERARLO CON EL SIGUIENTE FACTOR

       NF1=NFR
       DO M=1,NFR
        J1(M)=JR(M)
        DO K1=1,4
          HFU41(K1,M)=HFU4R(K1,M)
        END DO
        DO K1=1,JR(M)
         F1(K1,M)=FR(K1,M)
         DO K2=1,3
          HFU31(K2,K1,M)=HFU3R(K2,K1,M)
         END DO
        END DO
       END DO


      END DO
      
     
C--------FIN DE LOOP PARA MULTIPLICACION

    



C---------------- salida------
C    HFU4R,HFU3R,FR,JR,NFR 
    


C      write(*,*) "acabe multdy"
C FIN DE SUBRUTINA MULTDY
      END
C--------------------------------------------------------------------


      SUBROUTINE PDY3 (H,HT,HR,NDY3,NDY3MAX)
c**********************************************************************
c*    programa para multiplicar diagramas de Young DE 3 RENGLONES
c*      H(3) y HT(3) son los diagramas de Young a multiplicarse
c*      HR(3,NDY3MAX) son los diag. de Young  resultantes
c*      NDY3  numero de diagramas de Young  resultantes
c**********************************************


     

C DECLARACION DE VARIABLES
      INTEGER NDY3,NDY3MAX
      INTEGER H(3),HT(3), HM(3), HR(3,NDY3MAX)
      INTEGER CON


      CON=0
C REGLAS DE LITTLEWOOD
      
      DO H1A=MAX(0,HT(1)-(H(1)-H(3))),HT(1)
           
       DO H2A=MAX(0,HT(1)-H1A-(H(2)-H(3))),MIN(HT(1)-H1A,H(1)-H(2))         

          HM(1)=H1A
          HM(2)=H2A
          HM(3)=HT(1)-H1A-H2A


C         PONER LAS B'S

         DO H2B=MAX(0,HT(2)-(H(2)+HM(2)-H(3)-HM(3))),MIN(HT(2),HM(1))
          DO H3B=HT(2)-H2B,MIN(HT(2)-H2B,HM(1)+HM(2)-H2B)
           DO H3C= HT(3),MIN(HT(3),H2B) 
             CON=CON+1
             HR(1,CON)=H(1)+HM(1)
             HR(2,CON)=H(2)+HM(2)+H2B
             HR(3,CON)=H(3)+HM(3)+H3B+HT(3)

           END DO  
          END DO
         END DO      



       END DO


      END DO

C SALIDA
      NDY3=CON
C     Y LOS HR

C FIN DE SUBRUTINA PDY3

      END
C---------------------------------------------------------------------



      SUBROUTINE PDY4 (H,HT,HR4,NDY4,NDY4MAX)

c**********************************************************************
c*    programa para multiplicar diagramas de Young de 4 renglones
c     H(4) y HT(4) son los diagramas de Young a multiplicarse
c*      HR(4,NDY4MAX) son los diag. de Young  resultantes
c*      NDY4  numero de diagramas de Young  resultantes
c***************************



C DECLARACION DE VARIABLES
      INTEGER RE
      PARAMETER (RE=4)
      INTEGER NDY4,NDY4MAX
      INTEGER H(RE),HT(RE), HA(RE),HB(RE), HC(RE),HR4(RE,NDY4MAX)
      INTEGER CON


      nto=h(1)+h(2)+ht(1)+ht(2)
      CON=0
      do n=abs(h(1)-ht(1)-h(2)+ht(2)),h(1)+ht(1)-h(2)-ht(2),2
         con=con+1
       Hr4(1,con)=(nto+n)/2
       hr4(2,con)=(nto-n)/2
       hr4(3,con)=0
       hr4(4,con)=0
       end do
C SALIDA
      NDY4=CON
C    Y LOS HR4
      
C  FIN DE SUBRUTINA PDY4
      END





C*******************FUNCIONES*******************

C FUNCION D3
       INTEGER FUNCTION D3(X)
       INTEGER X

       D3=NINT((REAL(X)/3.0)+1.0/3.0)

       END

C FUNCION D2
       INTEGER FUNCTION D2(X)
       INTEGER X

       D2=NINT((REAL(X)/2.0)+1.0/4.0)

       END

C FUNCION NSRTS
       INTEGER FUNCTION NSRTS(X)
       INTEGER X

       INTEGER Y,M,L,N
       Y=0
       DO L=(x+1)/2,x
       
          Y=Y+1
       END DO
        
       NSRTS=Y
      END

C*************************************



