      SUBROUTINE  energycut(ee,maxe,maxs,
     &xnq00,xnq01,xnq10,xnq11,xng0,! valores de expectacion
     &nv00,nv01,nv10,nv11,ndeg,    !Seniorities de los edos ee(...) 
     &e0,ninxu)  
cESTA SUBRUTINA USA LOS CORTES 
c  N_{00}+N_{01}+N_{10}+N_{11}<= 2j  (o nqmax!!)
c  N_{01}<= 2j/2
c  N_{10}<= 2j/3
c  N_{11}<= 2j/6  
c 
C**********************************************************************
C*                                                                    *
C*       PROGRAMA PARA DIAGONALIZAR EL HAMILTONIANO 
C*          
c*        H=wf ( 2*N_f + (2om-2j)) + 2wb N_b
c*          + SUM_i V_i ( :(B^t + B )^2: (1-N_f/2j)  b 
c*          +             (1-N_f/2j) :(B^t + B )^2:  b^t )
c*
c*          PARA LOS  SECTORES (lam,mu)J^P                            *
c*          de las variables jv**(...)                                *
c*                                                                    *
C*                                                                    *
c*     ENTRADA (TODAS EN SENTENCIAS common,excepto maxe y maxs):             *
c*     
c*      Para dimensionar a priori en MAIN ee() y demas variables:
c*                 maxs,maxs      
c*      Numero de eigenvalores que se quieren
c*      para cada sector (lam,mu) J^P: 
c*                 neigw
c*      Restar la energia del vacio ( ee(1,0,0,0) ) 
c*      para  omega y pseudoespin fijos, 1->si, otro->no.
c*                 ne0
c*      VARIABLE PARA DECIDIR SI SE CALCULAN <N>
c*                 ifit0 (1 no se calculan, 0 si)      
C*      PARAMETROS DEL HAMILTONIANO:                                  *
C*                 wf,wb,v1,v2,v3,v4,v5,v6,v7,v8                      *
C*      Degeneracion de los niveles (2om) y seudosespin (2J):         *
c*                 ndomega,ndj
C*      Limites al numero de pares cuarks y  glueballs:
c*                 nqmax,ngmax           *
c         EL VALOR DE ESTAS VARIABLES DEBE AUMENTARSE PARA OBTENER 
c         CONVERGENCIA EN EL ESPECTRO DE BAJAS ENERGIAS PERO 
c*        DISMINUIRSE PARA QUE EL TAMANIO DE LA MATRICES NO IMPIDA
c*        DIAGONALIZARLAS EN TIEMPOS RAZONABLES.                     *
c*      Limites por tipo al numero de pares de cuarks y glueballs :
c*         mqest00,mqest01,mqest10,mqest11,mg0est,etop
c*
c         ESTAS VARIABLES PERMITEN DISMINUIR EL TAMANIO DE LAS
c*        MATRICES REDUCIENDO EL NUMERO DE PARES DE ALGUN TIPO.
c*        ES MUY UTIL CUANDO ALGUNA O ALGUNAS DE LAS CONSTANTES
c*        DE INTERACCION DE ALGUN CANAL ES MUY PEQUENIA, EN ESE CASO 
c*        NO SE ALTERAN LOS RESULTADO SI SE CORTA HASTA NUMERO 
c*        PEQUENIOS EL NUMERO DE PARES CORRESPONDIENTES A ESE O
c*        ESOS CANALES.
c*      Valores de las seniorities para cada sector (lam,mu) J^P:
c*        jl1,jv110,jla1,jn000,jv111,jla2,jmu2,jl2,jmultot,jindex  
c*
c*        LAS SENIORITIES ANTERIORES SON GENERADAS POR EL PROGRAMA
c*        nv-space.f ESCRITO  POR PETER   
c*      espin minimo y maximo:
c*                  smin,smax
c*        ES IMPORTANTE QUE SMIN=0 SI SE QUIERE OBTENER LA ENERGIA
c*        DEL ESTADO BASE.      
c*                                                                    *
C*   SALIDA:     ee,ndeg,xn*,ninxu,nv*                                *
C*               EIGENVALORES,degeneracion, <N_f>, <N_b> , e0(vacio), *
c*               numero de eigenvalores para cada sector              *
c*               y seniorities de los edos ee().                      *
c*                                                                    *
C*                                                                    *
C*  SERGIO LERMA ultima modificacion 13 sep  2002                     *
C**********************************************************************
      REAL*8  wf,wb,v1,v2,v3,v4,v5,v6,v7,v8,xc
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop
      INTEGER NGMAX,nqmax,ndomega,ndj,smin,smax,ifit0      
      parameter(lmax=20,lamu=20,    ! max. value of lamda,mu
     &          maxind=900) ! max. number of states N=seniority
      dimension jl1(maxind,0:lamu,0:1,0:lmax)
      dimension jv110(maxind,0:lamu,0:1,0:lmax)
      dimension jla1(maxind,0:lamu,0:1,0:lmax)
      dimension jn000(maxind,0:lamu,0:1,0:lmax)
      dimension jv111(maxind,0:lamu,0:1,0:lmax)
      dimension jla2(maxind,0:lamu,0:1,0:lmax)
      dimension jmu2(maxind,0:lamu,0:1,0:lmax)
      dimension jl2(maxind,0:lamu,0:1,0:lmax)
      dimension jmultot(maxind,0:lamu,0:1,0:lmax)
      dimension jindex(0:lamu,0:1,0:lmax)
C------------- VARIABLES  INTERNAS------------------------
C seniorities
      INTEGER  VS0,VS1,NQ0I,L0,LAM,NU,L1 
C Tamanio de matriz para un conjuntio dado de seniorities
      INTEGER NJX,NX
C numero de eigenvalores y eigenvectores que pido a GIVENS.
      INTEGER NEIG
C TAMANIO MAXIMO DE  MATRIZ A DIAGONALIZAR...
      integer neigmax,njxmax
c IMPORTANTE LOS VALORES SIGUIENTES!!!!!!!!!!!!!!!!
      parameter(neigmax=2602,njxmax=2602)
C EIGENVALORES Y EIGENVECTORES 
      REAL  E(neigmax),VECT(njxmax,neigmax),INTE(NJXMAX*NEIGMAX)

C--------------------- SALIDA-----------------------
c eigenvalues for  each  spin,flavour and parity values.        
      real*8  ee(maxe,0:maxs,0:1,0:1),e0
c expectacion values of number of gluons and quarks  
      real*8  xnq00(maxe,0:maxs,0:1,0:1),nq00
      real*8  xnq01(maxe,0:maxs,0:1,0:1),nq01
      real*8  xnq10(maxe,0:maxs,0:1,0:1),nq10
      real*8  xnq11(maxe,0:maxs,0:1,0:1),nq11
      real*8  xng0(maxe,0:maxs,0:1,0:1),ng0  
c Seniorities de los estados ee( , , , )----------
      integer nv00(maxe,0:maxs,0:1,0:1),nv01(maxe,0:maxs,0:1,0:1)
     & ,nv10(maxe,0:maxs,0:1,0:1),nv11(maxe,0:maxs,0:1,0:1)
     & ,ndeg(maxe,0:maxs,0:1,0:1) 
c----------------------
c number of eigenvalues of each J^p(lam,nu) sector (maxe or J^psector
c matrix size)
      integer ninxu(0:maxs,0:1,0:1)
      
C----FUNCIONES--------
C    NUMERO DE RENGLONES DE UNA MATRIZ DADO UN SECTOR Y LIMITES NMAX.
       INTEGER FNJX
c---!!!!!!!!!SENTENCIAS COMMON!!!!!!!!!!!!!!!1
      common /senior/jl1,jv110,jla1,jn000,jv111,jla2,jmu2,jl2,
     &               jmultot,jindex
      common /data2/wf,wb,v1,v2,v3,v4,v5,v6,v7,v8,xc,ifit0
      common /dat/ndj,ndomega
      common /datain/smin,smax,ngmax,nqmax,neigw,ne0
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop

c inicializando variables:
     
c      data ee /(maxe*(maxs+1)*4))*0.0/
c      data xnq00 /(maxe*(maxs+1)*4)*0.0/
c      data xnq01 /(maxe*(maxs+1)*4)*0.0/
c      data xnq10 /(maxe*(maxs+1)*4)*0.0/
c      data xnq11 /(maxe*(maxs+1)*4)*0.0/
c      data xng0  /(maxe*(maxs+1)*4)*0.0/
c      data ninxu /((maxs+1)*4)*0/
    
      e0=0.0
       do mun1=0,1
         do mun2=0,1
            do mun3=0,maxs
               do mun4=1,maxe
                  ee(mun4,mun3,mun2,mun1)=0.0
                  xnq00(mun4,mun3,mun2,mun1)=0.0
                  xnq01(mun4,mun3,mun2,mun1)=0.0
                  xnq10(mun4,mun3,mun2,mun1)=0.0
                  xnq11(mun4,mun3,mun2,mun1)=0.0
                  xng0(mun4,mun3,mun2,mun1)=0.0
                  nv00(mun4,mun3,mun2,mun1)=0
                  nv01(mun4,mun3,mun2,mun1)=0
                  nv10(mun4,mun3,mun2,mun1)=0
                  nv11(mun4,mun3,mun2,mun1)=0
                  ndeg(mun4,mun3,mun2,mun1)=0 
               end do
               ninxu(mun3,mun2,mun1)=0
            end do
         end do
       end do   



      nlimq=min(ndj,nqmax)
c checking if the greatest matrix is smaller than the allowed one 
    
      NJX=FNJX(0,0,0,0,NGMAX,nlimq,ndj,mqest00,
     &mqest01,mqest10,mqest11,mg0est,etop)  
      if (njx.gt.njxmax) then
           write(6,*) "matrix greater than  allowed. Change the para
     &meters njxmax and neigmax!!"
           write(6,*) "greatest matrix size=",njx
           write(6,*) "njxmax=",njxmax, "neigmax=",neigmax
           stop
      end if
  
      DO nl0=0,smax   !spin
      DO npar=0,1   !parity
      DO nla0=0,1  !flavour
 
       ne=0        

       DO nindex=1,jindex(nla0,npar,nl0)
C       ASIGNAR SENIORITIES DE CADA SECTOR
        vs0=jv110(nindex,nla0,npar,nl0)
        vs1=jv111(nindex,nla0,npar,nl0)
        nq0i=jn000(nindex,nla0,npar,nl0)
        l0=jl1(nindex,nla0,npar,nl0)
        ndegen=jmultot(nindex,nla0,npar,nl0)
        lam=nla0
        nu=nla0
        l1=nl0
        neig=neigw  ! IMPORTANTE,NUMERO DE EIGENVALORES PARA CADA SECTOR
        NJX=FNJX(VS0,VS1,NQ0I,L0,NGMAX,Nlimq,ndj,mqest00,
     &mqest01,mqest10,mqest11,mg0est,etop)
        NX=NJX

        if (neig.gt.njx) neig=njx

        CALL DIHSENF (VS0,VS1,NQ0I,L0,
     &  NJX,NX,NEIG,
     &  E,INTE)
c         write(*,*) "BOTELLON"
c reconstructing  the eigenvectors
        mk3=0
        do mk=1,neig
            do mk2=1,njx
               mk3=mk3+1
               VECT(MK2,MK)=INTE(MK3)
            END DO
        END DO   
C-----ORDENANDO LOS EIGENVALORE PARA FIJAS J^P (LAM,NU)
c  in the begining of each J^P(lam,mu) sector... 
        if (NINDEX.EQ.1) then
          ne=neig
          DO NMT=1,NEIG
            ee(nmt,nl0,nla0,npar)=e(neig+1-nmt)
            nv00(nmt,nl0,nla0,npar)=nq0i
            nv01(nmt,nl0,nla0,npar)=l0
            nv10(nmt,nl0,nla0,npar)=vs0
            nv11(nmt,nl0,nla0,npar)= vs1
            ndeg(nmt,nl0,nla0,npar)=ndegen
c si es fit no calcular valores de expectacion
           if (ifit0.eq.1) go to 3 
c  calculando valores de expectacion
            nq00=0.0
            nq01=0.0
            nq10=0.0
            nq11=0.0
            ng0=0.0
            I=0
            NQI=VS0+VS1+L0+NQ0I
            DO Ng=0,ngmax                       !!ROTULO
ccc            if (ng*mg0est .le. etop) then   
             DO nqtot=nqi,min(ndj,nqmax),2
             DO NQT=VS0+VS1,NQTOT-L0-NQ0I,2 
             NQ=NQTOT-NQT
             DO NQT0=VS0,NQT-VS1,2             !!ROTULO
             NQT1=NQT-NQT0                     !!ROTULO
             DO NQ0=NQ0I,NQ-L0,2               !!ROTULO 
             NQ1=NQ-NQ0                        !!ROTULO
ccc             if(mqest00*nq0+mqest01*nq1+mqest10*nqt0+mqest11*nqt1
ccc     &           +mg0est*ng  .le.etop ) then            
             if( (nq1.le.ndj/2.and. nqt0.le.ndj/3).and.nqt1.le.ndj/6) !CAMBIOS
     &       then

              i=i+1
              nq00=nq00+real(nq0)*(vect(i,neig+1-nmt)**2)
              nq01=nq01+real(nq1)*(vect(i,neig+1-nmt)**2)
              nq10=nq10+real(nqt0)*(vect(i,neig+1-nmt)**2)
              nq11=nq11+real(nqt1)*(vect(i,neig+1-nmt)**2)
              ng0=ng0+real(ng)*(vect(i,neig+1-nmt)**2)
             end if 
             END DO
             END DO
             END DO
             END DO
ccc            end if
            END DO 
            xnq00(nmt,nl0,nla0,npar)=nq00
            xnq01(nmt,nl0,nla0,npar)=nq01
            xnq10(nmt,nl0,nla0,npar)=nq10
            xnq11(nmt,nl0,nla0,npar)=nq11 
            xng0(nmt,nl0,nla0,npar)=ng0 
 3          continue
          end do !nmt
          go to 33
        end if  

c----- COMPARANDO EIGENVALORES Y ORDENANDO 

        do ip=neig,1,-1
           is=ne+1  
           men=1
           do while (men.eq.1)
               men=0
               is=is-1
               if (is.eq.0) go to 890
               if (e(ip).lt.ee(is,nl0,nla0,npar)) men=1
 890           continue
           end do
           
           do k=min(ne+1,neigw),is+2,-1
               ee(k,nl0,nla0,npar)=ee(k-1,nl0,nla0,npar)
               nv00(k,nl0,nla0,npar)= nv00(k-1,nl0,nla0,npar)
               nv01(k,nl0,nla0,npar)= nv01(k-1,nl0,nla0,npar)
               nv10(k,nl0,nla0,npar)= nv10(k-1,nl0,nla0,npar)
               nv11(k,nl0,nla0,npar)= nv11(k-1,nl0,nla0,npar)
               ndeg(k,nl0,nla0,npar)= ndeg(k-1,nl0,nla0,npar)
               xnq00(k,nl0,nla0,npar)=xnq00(k-1,nl0,nla0,npar)
               xnq01(k,nl0,nla0,npar)=xnq01(k-1,nl0,nla0,npar)
               xnq10(k,nl0,nla0,npar)=xnq10(k-1,nl0,nla0,npar)
               xnq11(k,nl0,nla0,npar)=xnq11(k-1,nl0,nla0,npar) 
               xng0(k,nl0,nla0,npar)=xng0(k-1,nl0,nla0,npar) 
           end do

           if (is+1.le.neigw) then
              ne=min(ne+1,neigw)
              ee(is+1,nl0,nla0,npar)=e(ip)
              nv00(is+1,nl0,nla0,npar)=nq0i 
              nv01(is+1,nl0,nla0,npar)=l0 
              nv10(is+1,nl0,nla0,npar)=vs0 
              nv11(is+1,nl0,nla0,npar)=vs1  
              ndeg(is+1,nl0,nla0,npar)=ndegen              
              if (ifit0.eq.1) go to 26 
C   calculando valores de expectacion        
              nq00=0.0
              nq01=0.0
              nq10=0.0
              nq11=0.0
              ng0=0.0
              I=0
              NQI=VS0+VS1+L0+NQ0I
              DO Ng=0,ngmax                      !!ROTULO
cccc              if (ng*mg0est .le. etop) then   
               DO nqtot=nqi,min(ndj,nqmax),2
               DO NQT=VS0+VS1,NQTOT-L0-NQ0I,2 
               NQ=NQTOT-NQT
               DO NQT0=VS0,NQT-VS1,2             !!ROTULO
               NQT1=NQT-NQT0                     !!ROTULO
               DO NQ0=NQ0I,NQ-L0,2               !!ROTULO 
               NQ1=NQ-NQ0                        !!ROTULO
ccc               if(mqest00*nq0+mqest01*nq1+mqest10*nqt0+mqest11*nqt1
ccc     &             +mg0est*ng  .le.etop ) then            
               if( (nq1.le.ndj/2.and. nqt0.le.ndj/3).and.nqt1.le.ndj/6) !CAMBIOS
     &         then
                i=i+1
                nq00=nq00+real(nq0)*(vect(i,ip)**2)
                nq01=nq01+real(nq1)*(vect(i,ip)**2)
                nq10=nq10+real(nqt0)*(vect(i,ip)**2)
                nq11=nq11+real(nqt1)*(vect(i,ip)**2)
                ng0=ng0+real(ng)*(vect(i,ip)**2)               
               end if 
               END DO
               END DO
               END DO
               END DO
ccc              end if
              END DO 
              xnq00(is+1,nl0,nla0,npar)=nq00
              xnq01(is+1,nl0,nla0,npar)=nq01
              xnq10(is+1,nl0,nla0,npar)=nq10
              xnq11(is+1,nl0,nla0,npar)=nq11 
              xng0(is+1,nl0,nla0,npar)=ng0 
 26           continue
           end if        
        end do  ! ip
 33     continue
c        write(*,*) " ahora los ordenados, hasta ahora"
c        write(*,*) "ne= ",ne
c        write(*,*) "energia, <nq00>"
c        do klk=1,ne
c        write(*,*) ee(klk,nl0,nla0,npar),xnq00(klk,nl0,nla0,npar)
c        end do
c        write(*,*) " (un numero para continuar)"
c        read(*,*) nnnn
       END DO  !  nindex
c  numero de eigenvalores para cada sector J^P(lam,nu) (maximo
C  posible por tamanio de matriz  o  neigw)
c       write(*,*) nl0,npar,nla0," : ",ne
      ninxu(nl0,nla0,npar)=ne
c      ne=0
c      write(*,*) ninxu(nl0,nla0,npar),"y",ninxu(0,0,0)
      END DO   ! nla0 (flavour)
      END DO   ! npar (paity)
      END DO   !nl0 (spin)

C--------SALIDA----------------------------
c energia vacio
      e0=ee(1,0,0,0)

c Substracting vacuum energy...
      if (ne0.eq.1) then 
       DO nl0=0,smax   !spin
        DO npar=0,1    !parity
         DO nla0=0,1   !flavour 
          do nume=1,ninxu(nl0,nla0,npar)
            ee(nume,nl0,nla0,npar)= ee(nume,nl0,nla0,npar)-e0
           end do
          END DO 
        END DO  
       END DO   
      end if 
       return 

      END
C-----FIN SUBRUTINA energy



        


C**********************************************************************
      SUBROUTINE DIHSENF (VS0,VS1,NQ0I,L0,
     &   NJX,NX,NEIG,
     &   Eni,VECT)
C**********************************************************************
C*      ESTA SUBRUTINA DIAGONALIZA EL HAMILTONIANO DEL MODELO PARA 
C*      SENIORITIES FIJAS (VS0,VS1,NQ0I,L0). USA TODAS LAS
c*       INTERACCIONES,         CONSIDERANDO
C*      PARES DE QUARKS COMO BOSONES (MAPEO BOSONICO A ORDEN 0).
c*      introduce el  corte (1-n/2om) en el hamiltoniano
c*
C*       Usa subrutina GIVENS (matrices simetricas)
C*
C*       ENTRADA:  PARAMETROS DEL HAMILTONIANO
C*                 MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8      
C*                 VALORES DEL  SECTOR  (SENIORITY, ETC...)
C*                 VS0,VS1,NQ0I,L0,LAM,NU,L1 
C* 
C*     
C*              NUMERO MAXIMO DE BOSONES Y PARES DE QUARKS CONSIDERADOS
C*
C*                 TAMANIO DE LA MATRIZ Y CONSIDERADA POR GIVENS
C                              NJX Y  NX 
C*
C*              NUMERO DE EIGENVALORES Y VECTORES A OBTENER: NEIG
C*      
C*            
C*      SALIDA:   EIGENVECTORES Y EIGENVALORES
C*                 E,  VECT
C* POR SERGIO LERMA   13 sep  2002
C**********************************************************************

C ENTRADA
       REAL*8  wf,wb,v1,v2,v3,v4,v5,v6,v7,v8,xc
c corte
       real*8 mqest00,mqest01,mqest10,mqest11,mg0est,etop
       INTEGER  VS0,VS1,NQ0I,L0,LAM,NU,L1 
       INTEGER NGMAX,Ndomega,smin,smax,ndj,ifit0,nqmax 
       INTEGER NJX
       INTEGER NX,NEIG,neigw
C SALIDA
       REAL Eni(NEIG), VECT(NJX,NEIG)
C    INTERNAS
       REAL  A((NJX*(NJX+1))/2) ! ,HAM(njx,njx)
ccc      REAL  H
        INTEGER NQI
ccc      real DT 
 
         common /dat/ndj,ndomega
         common /data2/wf,wb,v1,v2,v3,v4,v5,v6,v7,v8,xc,ifit0
         common /corte/mqest00,mqest01,mqest10,mqest11,mg0est,etop
         common /datain/smin,smax,ngmax,nqmax,neigw,ne0
     
c      write(*,*) "PODADORA"
C+++++++++++construimos el arreglo unidimensional A 
    
      ic=0
      I=0       
      NQI=VS0+VS1+L0+NQ0I
c++++++++++++  Columnas
      DO Ng0=0,ngmax                      !!ROTULO
c      if (ng0*mg0est .le. etop) then   
        DO nqtot=nqi,min(ndj,nqmax),2
        DO NQT=VS0+VS1,NQTOT-L0-NQ0I,2 
        NQ=NQTOT-NQT
        DO NQT0=VS0,NQT-VS1,2             !!ROTULO
        NQT1=NQT-NQT0                     !!ROTULO
        DO NQ0=NQ0I,NQ-L0,2               !!ROTULO 
        NQ1=NQ-NQ0                        !!ROTULO
        if( (nq1.le.ndj/2.and. nqt0.le.ndj/3).and.nqt1.le.ndj/6) !CAMBIOS
     &        then
          ic=ic+1
C++++++++++++ Renglones+++++++++++++++++++++++++++++++++++++
          DO  ng0b=0,ng0                              !ROTULO
c          if (ng0b*mg0est .le. etop) then     
           nqtotblim=min(ndj,nqmax)
           if (ng0b.eq.ng0) nqtotblim=nqtot
           do nqtotb=nqi,nqtotblim,2             
           NQTBLIM=NQTOTB-L0-NQ0I
           IF (nqtotb.EQ.nqtot .AND. NG0B.EQ.NG0) NQTBLIM=NQT
           do NQTB=VS0+VS1,NQTBLIM,2   
           NQB=NQTOTB-NQTB          
           NQT0BLIM=NQTB-VS1
           IF ((Ng0b.EQ.ng0 .AND. Nqtotb.EQ.nqtot).AND.
     &         (NQTB.EQ.NQT )) NQT0BLIM=NQT0
           do NQT0B=VS0,NQT0BLIM,2                   !ROTULO
           NQT1B=NQTB-NQT0B                          !ROTULO
           NQ0BLIM=NQB-L0
           IF(((Ng0b.EQ.ng0 .AND. Nqtotb.EQ.nqtot).AND.
     &         (NQTB.EQ. NQT )).AND. (NQT0B.EQ.NQT0)) NQ0BLIM=NQ0
           do NQ0B=NQ0I,NQ0BLIM,2                    !ROTULO 
           NQ1B=NQB-NQ0B                             !ROTULO
         if( (nq1b.le.ndj/2.and. nqt0b.le.ndj/3).and.nqt1b.le.ndj/6) !CAMBIOS
     &        then
    
             I=I+1

C+++++++++++++++++ ELEMENTOS DE MATRIZ ++++++++++++++++++++++++++++++++
             A(I)=0.0
             
C----------------DIAGONAL -----------------
      if ( ( (nq0.eq.nq0b   .and.  nq1.eq.nq1b)      .and. 
     &       (nqt0.eq.nqt0b .and.  nqt1.eq.nqt1b) )  .and.
     &         ng0.eq.ng0b  )      
     &     A(I)=wf*(2.0*(NQ0+NQ1+NQT0+NQT1)+ndomega-ndj) +
     &          2.0*wb*ng0
C------Interaction Terms 
c (only b terms contribute to this side of the symmetric  matrix)

      if (ng0b.eq.(ng0-1).and. ndj.ne.0) then   
    
c+++++++++++++Pair creation and annihilation++++++++++++++++++++
c              (  (B^t)^2 b +  b^t (B)^2) )
c                 
c                        AND
c
c++++++++++++    vacuum correlations   +++++++++++++++++++++++++
c              (  (B)^2 b  +  b^t (B^t)^2 )           

c ----------------     (0,0)  0   ----------------------

        if (nq1.eq.nq1b.and.(nqt0.eq.nqt0b .and. nqt1.eq.nqt1b)) then  

           if (nq0b.eq.nq0+2)
     &       A(I) = v1*SQRT(1.0*NQ0B*(NQ0B-1)*NG0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj)

           if (nq0b.eq.nq0-2)
     &       A(I) = v1*SQRT(1.0*NQ0*(NQ0-1)*NG0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj) !! cambiar a variables "b" para  ( (B^t)^2 (1-nf/2j) + (1-nf/2j) (B)^2)             

        end if   

c ----------------     (0,0)  1   ----------------------

        if (nq0.eq.nq0b.and.(nqt0.eq.nqt0b .and. nqt1.eq.nqt1b)) then  

           if (nq1b.eq.nq1+2)
     &       A(I) = v2*SQRT(1.0*(NQ1B-L0)*(NQ1B+L0+1)*NG0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj) 
     

           if (nq1b.eq.nq1-2)
     &       A(I) =  v2*SQRT(1.0*(NQ1-L0)*(NQ1+L0+1)*NG0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj)   !! cambiar a variables "b" para  ( (B^t)^2 (1-nf/2j) + (1-nf/2j) (B)^2)             

        end if 

c ----------------     (1,1)  0   ----------------------

        if (nqt1.eq.nqt1b.and.(nq0.eq.nq0b .and. nq1.eq.nq1b)) then  

           if (nqt0b.eq.nqt0+2)
     &       A(I) = v3*SQRT(1.0*(NQT0B-VS0)*(NQT0+8+VS0)*NG0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj) 
     

           if (nqt0b.eq.nqt0-2)
     &       A(I) = v3*SQRT(1.0*(NQT0-VS0)*(NQT0B+8+VS0)*NG0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj)  !! cambiar a variables "b" para  ( (B^t)^2 (1-nf/2j) + (1-nf/2j) (B)^2)             

        end if 

c ----------------     (1,1)  1   ----------------------

        if (nqt0.eq.nqt0b.and.(nq0.eq.nq0b .and. nq1.eq.nq1b)) then  

           if (nqt1b.eq.nqt1+2)
     &       A(I) = v4*SQRT(1.0*(NQT1B-VS1)*(NQT1+24+VS1)*ng0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj) 

           if (nqt1b.eq.nqt1-2)
     &       A(I) =  v4*SQRT(1.0*(NQT1-VS1)*(NQT1B+24+VS1)*ng0)
     &                *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj) !! cambiar a variables "b" para  ( (B^t)^2 (1-nf/2j) + (1-nf/2j) (B)^2)             

        end if 


c+++++++++++++++++++   Scattering terms  ++++++++++++++++++++++++++++
C                 (  2 (B^t B) (b^t + b) )

       if ( (nqt0.eq.nqt0b.and.nqt1b.eq.nqt1)  .and.
     &       (nq0.eq.nq0b .and. nq1.eq.nq1b)  )  
     &       A(I)=2.0*sqrt(1.0*ng0)*(v1*nq0+v2*nq1+v3*nqt0+v4*nqt1)
     &               *(1.0-xc*(NQ0+NQ1+NQT0+NQT1)/ndj) 
             
      end if       
      
           end if   
           end do !NQ0B
           end do !NQT0B
           end do !NQTB
           end do !nqtotb   
c          end if 
          end do !ng0b      
        end if  
        END DO !NQ0
        END DO !NQT0
        END DO !NQT
        END DO !nqtot
c      end if
      END DO ! ng0


c      write(*,*) "construidO EL ARREGLO (ORD=1)"
  
       if (njx.ne.ic.or.  i.ne.(njx*(njx+1))/2) then
          write(6,*) "Calculated matrix size doesn't match
     & to actual size"
          write(6,*) "calculated",njx,"  actual:",ic
         
          write(6,*) "calculated A's size:", (njx*(njx+1))/2
          write(6,*) "actual A's size :", i
          stop
       end if   


      

      CALL  GIVENS (A,Eni,VECT,NX,NEIG,NJX)
       
      
C ---- SALIDA
 
c      write(*,*) "En dihsenf"
     
c      write(*,*) "mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8"
c      write(*,*)  mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8
c      write(*,*)  "VS0,VS1,L0,NQ0I"
c      write(*,*)  VS0,VS1,L0,NQ0I
c      DO NN=1,NEIG
c        WRITE(*,*) NN,"o EIGENVALOR",E(NN)
c      END DO
   
       
      
      END
C***********FIN DE SUBRUTINA DIHSENF 


     
C--------FUNCION FNJX--------------------------------------------
      INTEGER FUNCTION FNJX(VS0,VS1,NQ0I,L0,NGMAX,Nqmax,ndj,mqest00,
     &mqest01,mqest10,mqest11,mg0est,etop)
      INTEGER VS0,VS1,NQ0I,L0,NGMAX,Ndj
      real*8 mqest00,mqest01,mqest10,mqest11,mg0est,etop
      NQI=VS0+VS1+L0+NQ0I
      FNJX=0

      do ng0=0,ngmax
ccc       if (ng0*mg0est .le. etop) then   
        DO N=NQI,nqmax,2
         DO NQT=VS0+VS1,N-L0-NQ0I,2
          nq=n-nqt
          do nqt0=vs0,nqt-vs1,2
           nqt1=nqt-nqt0
           do nq0=nq0i,nq-l0,2
            nq1=nq-nq0 
      if( (nq1.le.ndj/2.and. nqt0.le.ndj/3).and.nqt1.le.ndj/6) !CAMBIOS
     &        !CAMBIOOOOOO
c              if(mqest00*nq0+mqest01*nq1+mqest10*nqt0+
c     &         mqest11*nqt1+mg0est*ng0 .le.etop ) 
     &           FNJX=FNJX+1
           end do
          end do   
         END DO
        END DO               
c       end if 
      end do     
     

      END 
C FIN FUNCION FNJX---------------------------------------------
























