      program tontsave
c********************************************************************
c
c Programa que usa eigenfla.out (eigenvalores para todo pseudoespin)
c para calcular la funcion de particion
c del   Hamiltoniano bosonico
c 
c benoetigt     : u6s.o
c                 mut1fla.out
c Eingagefile   : ztot.in
c Ausgabefiles  : ztotfla.out ->  T,energia,calor,barion,color,delcol,strange
c                 prodprobfla.out ->   auf (T,mub,mus)-Phasenlinie
c
c*********************************************************************
      implicit real*8 (A-H,O-Z)
      REAL*8  MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8,xc
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop  !CORTE
      real*8  y,I,iz,numbar,numpart
      real*8  glum(38)
      integer muglu(38)
      integer smin,smax,ng0max,nqmax,ndomega,ndj,ifit0,maxe
      integer ntest,mtest,ktest,itest,ztest
c      programa principal lee parametros y varibales de entrada
      common /dat/ ndj,ndomega,ndjef,nfer
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0,lamax
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop
      common /temp/tmin,tmax,tdel
      common /mu/vmin,vmax,vdel,ntest,mtest,ktest,itest,ztest
      common /mum/vB,vS,vIz,numBar,radel,bagpr
      common /glue/glum,muglu,numpart
      open(unit=1,file="ztot.in")
c      open(unit=3,file="ztot1fla.out")
      open(unit=9,file="gluespek.in")
      open(unit=10,file="ztotfla.out")
      open(unit=20,file="ztotfla00.out")
      open(unit=11,file="prodprobfla.out")
      open(unit=22,file="prodprobfla00.out")
      open(unit=2,file="eigenfla.out") 
      open(unit=12,file="mut1fla.out")  
      open(unit=25,file="expecfla.out")
c      open(unit=12,file="mut1fla.out")
      open(unit=13,file="radius.out")
      open(unit=26,file="radius00.out")
      open(unit=29,file="expec.out")
      open(unit=30,file="expec00.out") 
c      open(unit=40,file="resultverh.out") 
     
      read(1,*)
      read(1,*) MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8
      read(1,*)
      read(1,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop
      read(1,*)
      read(1,*) smin,smax,ng0max,nqmax,ndomega,lamax
      read(1,*)
      read(1,*) xc,ifit0
      read(1,*)
      read(1,*) neigw
      read(1,*) 
      read(1,*) tmin,tmax,tdel
      read(1,*) 
      read(1,*) vmin,vmax,vdel
      read(1,*)
      read(1,*) vB,vS,vIz
      read(1,*)
      read(1,*) vsmin,vsmax,vsdel
      read(1,*)
      read(1,*) ntest
      read(1,*)
      read(1,*) mtest    
      read(1,*)
      read(1,*) ktest 
      read(1,*)
      read(1,*) numpart
      read(1,*)
      read(1,*) bagpr,radel
      read(1,*)
      read(1,*) itest
      read(1,*)
      read(1,*) ztest

    
      write(3,*) "MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8"
      write(3,*) MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8
      write(3,*) "mqest00,mqest01,mqest10,mqest11,mg0est,etop"
      write(3,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop
      write(3,*) "smin,smax,ng0max,nqmax,ndomega"
      write(3,*) smin,smax,ng0max,nqmax,ndomega
      write(3,*) " xc,ifit0"
      write(3,*) xc,ifit0
      write(3,*) "neigw"
      write(3,*) neigw 
      write(*,*)    ndj,ndomega,ndjef,nfer,
     & mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0,
     &smin,smax,ng0max,nqmax,neigw,ne0,lamax,
     &mqest00,mqest01,mqest10,mqest11,mg0est,etop,tmin,tmax,tdel,
     &vmin,vmax,vdel,ntest,mtest,ktest,itest,ztest,vB,vS,vIz,numBar
     &,radel,bagpr,glum,muglu,numpart
      
      call principal 
      stop
      end 

      subroutine principal
      implicit real*8 (A-H,O-Z)
      REAL*8  MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8,xc,dmea,dmeb,dme
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop  !CORTE
      integer smin,smax,ng0max,nqmax,ndomega,ndj,ifit0,maxe,dimu6
c      parameter(lamax=4)
      dimension  etj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension xpf(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension xpg(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      integer ndtj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension numeig(0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      integer ntest,mtest,ktest,itest,ztest
      real*8 numbar,numpart!,alpha,nixw
      integer h(12)
      real*8  glum(38)
      integer muglu(38)
      dimension zz(0:ndomega),vez(0:ndomega),veez(0:ndomega)
      dimension zzs(0:ndomega),vib(0:ndomega),vyb(0:ndomega)
      dimension vpf(0:ndomega),vpg(0:ndomega)
      parameter(maxr=60)
      integer hu2a1(maxr),hu2a2(maxr), hu3a1(maxr),hu3a2(maxr)
     &       ,hu3a3(maxr)
      integer mult1(maxr),nra
      integer hu2b1(maxr),hu2b2(maxr), hu3b1(maxr),hu3b2(maxr)
     &        ,hu3b3(maxr)
      integer mult2(maxr),nrb
      integer ha(5),hb(5),lamb(maxr,0:3,0:3,0:3,0:3,0:3)
      integer mub(maxr,0:3,0:3,0:3,0:3,0:3)
      integer nds(maxr,0:3,0:3,0:3,0:3,0:3),ir(0:3,0:3,0:3,0:3,0:3)
      integer mult(maxr,0:3,0:3,0:3,0:3,0:3),h1,h2,h3,h4,h5

      common /dat/ ndj,ndomega,ndjef,nfer
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0,lamax
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop
      common /temp/tmin,tmax,tdel
      common /mu/vmin,vmax,vdel,ntest,mtest,ktest,itest,ztest
      common /mum/vB,vS,vIz,numBar,radel,bagpr
      common /glue/glum,muglu,numpart
      
c!!!!!!!!!!!!!!!!!!!!!!!!
c LEER DATOS DEL GLUE-ESPECTRUM
         
         read(9,*) 
         read(9,*) glum
         read(9,*) muglu

c LEER DATOS DE eigenfla.out y (en el caso) de expecfla.out
      read(2,*) evac
      do ndj=ndomega,0,-1
        do npar=0,1
          do nmu0=0,lamax
          do nla0=0,lamax
            do nl=0,smax
             read(2,*) ndjd,nld,nlad,nmud,npard,nlimd !2J,spin,lambda,par,nueig
        if (ifit0.eq.0) read(25,*) ndjde,nlde,nlade,nmude,nparde,nlimde 
      if (ndj.ne.ndjd)write(*,*) "0 error reading files"
      if (npar.ne. npard) write(*,*) "1 error reading eigenvalues"
      if (nla0.ne.nlad) write(*,*) "2 error reading eigenvalues"
      if (nl.ne.nld) write(*,*) "3 error reading files" 
      if(nmud.ne.nmu0)  write(*,*)  "4 error reading eigenvalues" 
             numeig(nl,nla0,nmu0,npar,ndj)=nlimd
               do nco=1,nlimd
                  read(2,*) ev,ndeg
                  if (ifit0.eq.0) then
                     read(25,*) xquar,xgluon
                     xpf(nco,nl,nla0,nmu0,npar,ndj)=xquar
                     xpg(nco,nl,nla0,nmu0,npar,ndj)=xgluon
                  end if   
                  etj(nco,nl,nla0,nmu0,npar,ndj)=ev
                  ndtj(nco,nl,nla0,nmu0,npar,ndj)=ndeg
              end do
            end do
          end do
          end do
        end do 
      end do
c      write(*,*) etj(15,0,0,0,18)
c      write(*,*) numeig(0,0,0,0)

      do h1=0,3
      do h2=0,h1
      do h3=0,h2
      do h4=0,h3
      do h5=0,h4
     
      call  U6s(h1,h2,h3,h4,h5,0,
     &           hu2a1,hu2a2,    ! SU(2)
     &           hu3a1,hu3a2,hu3a3, !SU(3)
     &           mult1,             ! multiplicidad
     &           nra,maxr)          !maxima dimension de los campos               
       ir(h1,h2,h3,h4,h5)=nra
        do nq=1,nra
         lamb(nq,h1,h2,h3,h4,h5)=hu3a1(nq)-hu3a2(nq)
         mub(nq,h1,h2,h3,h4,h5)=hu3a2(nq)-hu3a3(nq)
         nds(nq,h1,h2,h3,h4,h5)=hu2a1(nq)-hu2a2(nq)
         mult(nq,h1,h2,h3,h4,h5)=mult1(nq)
        end do
      end do   
      end do
      end do
      end do
      end do

      write(*,*) "REDUCCIONES FINALIZADAS"
      
      if (tdel.eq.0.0) then 
         tmax=tmin+1.0
         tdel=2.0
      end if
      if (vdel.eq.0.0) then 
         vmax=vmin+1.0
         vdel=2.0
      end if
c        Do t=tmin,tmax,tdel
c DO LOOP DE TEMPERATURA Y MU
c         Do v=vmin,vmax,vdel      
      do ll=1,(tmax-tmin)/tdel+1
c--------------------------------------------------------
c         read(40,*) nixw,alpha
c-------------------------------------------------------
         if(ntest.eq.1) then
            read(12,*) tl,vbl,vsl   !vs,vb
         end if
      if (ntest.eq.1) then
         vb=vbl
         vs=vsl
         t=tl
      end if

      if (ntest.eq.0) then 
         t=tmin+(ll-1)*tdel
      end if
      write(*,*) t,vb,vs
c ---------- Glueballspektrum ----------------------------
         zgb=1.0      
         if (mtest.eq.1) then
           do nsum=1,38   ! Achtung - VZ 
         zgb=zgb*(1.0/(1.0+exp(-glum(nsum)/t)))**(2.0*muglu(nsum)+1.0)
         zngb=zngb+((exp(-glum(nsum)/t))/(1.0+exp(-glum(nsum)/t)))
     &               *(2.0*muglu(nsum)+1.0)         
           end do
c           write(*,*) zgb
         end if
c----------------------------------------------------------------
c     calcula funcion de particion energia, al  cuadrado,
c             Y,I_z,  para j y t fijos
c           write(*,*) "ndomega",ndomega,t,neigw,smax

         do nel=ndomega,0,-1
           call part (zj,vid,vyd,ve,vee,t,nel,etj,ndtj,ktest
     &          ,numeig,neigw,smax,ndomega,vb,vs,viz,lamax,zgb,
     &                xpf,xpg,vf,vg)
           zz(nel)=zj
           vib(nel)=vid           
           vyb(nel)=vyd
           vez(nel)=ve
           veez(nel)=vee
           vpf(nel)=vf
           vpg(nel)=vg
         end do 

c         combinatoria (analogo a Kuriyama-Suma) 

*************************************************************
         ztesti=ztest
         ztests=ztest
        if (ztest.eq.2) then
         ztesti=0
         ztests=1
        end if
        do kktest=ztesti,ztests
         Z=0.0
         vbar=0.0
         vy1=0.0
         vy2=0.0
         vybo=0.0
         vi1=0.0
         vi2=0.0
         vibo=0.0
         vexe=0.0
         vexec=0.0
         vexn=0.0
         vcolor=0.0
         vcolcu=0.0
         vexndt=0.0  !No existe?!!
         vexns=0.0   !No existe?!!!
         vexg=0.0    !n0 existe?!! 
         vexqu=0.0
         vexqub=0.0
         vexpfer=0.0
         vexpglu=0.0     
 
         do nh1t=0,12
           if (kktest.eq.0) nh2ti=nh1t   
           if (kktest.eq.1) nh2ti=0 
         do nh2t=nh2ti,nh1t
           if (kktest.eq.0) nh3ti=nh1t   
           if (kktest.eq.1) nh3ti=0    
         do nh3t=nh3ti,nh2t 

c Asignar h(1),...,h(12) para un dado h1~,...,h3~
           do k1=1,nh3t
                  h(k1)=3
           end do
           do k2=nh3t+1,nh2t
                  h(k2)=2
           end do
           do k3=nh2t+1,nh1t
                  h(k3)=1
           end do
           do k4=nh1t+1,12
                  h(k4)=0
           end do
c-------------------------------------------------------------
         ndjef=h(1)+h(2)+h(3)+h(4)+h(5)+h(6)
     &       -( h(7)+h(8)+ h(9)+h(10)+h(11)+h(12) ) 
 
         nfer=h(1)+h(2)+h(3)+h(4)+h(5)+h(6)
     &       +( h(7)+h(8)+ h(9)+h(10)+h(11)+h(12) ) 

         numBar=(nfer-ndomega)/3.0 !omega cancela 

         numq= (h(7)+h(8)+ h(9)+h(10)+h(11)+h(12))
         numqb= ndomega-(h(1)+h(2)+h(3)+h(4)+h(5)+h(6))

          ha(1)=h(1)-h(6)
          ha(2)=h(2)-h(6)
          ha(3)=h(3)-h(6)
          ha(4)=h(4)-h(6)
          ha(5)=h(5)-h(6)


          hb(1)=h(7)-h(12)
          hb(2)=h(8)-h(12)
          hb(3)=h(9)-h(12)
          hb(4)=h(10)-h(12)
          hb(5)=h(11)-h(12)
c****DIMENSION U(6) DEL EDO DE MINIMO PESO
          dmealt=dimu6(h(1),h(2),h(3),h(4),h(5),h(6))*
     &     dimu6(h(7),h(8),h(9),h(10),h(11),h(12))
cLO SIGUIENTE SUSTITUYE LAS 2 LINEAS PREVIAS. 
c---------- antiquarks
      dmea=0.0
      zy1=0.0
      zi1=0.0
      do l=1,ir(ha(1),ha(2),ha(3),ha(4),ha(5))  ! nrb 
         lam=lamb(l,ha(1),ha(2),ha(3),ha(4),ha(5))!(hu3a1(l)-hu3a2(l))
         mu=mub(l,ha(1),ha(2),ha(3),ha(4),ha(5))!(hu3a2(l)-hu3a3(l))
         dmeao=0.0
         zi1o=0.0
         zy1o=0.0
         do np=0,lam      ! Sabor
            do nq=0,mu            ! Sabor
               da=0.0
               zya=0.0             
               zia=0.0
               Y= -(2.0*lam+mu-3.0*(np+nq))/3.0
               tI=(mu+np-nq)/2.0                    
             do tiz=-tI,tI           ! Sabor
              da=da+exp((vIz*tIz)/t)
              zia=zia+tiz*exp((vIz*tIz)/t)
             end do               ! Sabor
             dmeao=dmeao+da*exp(-vs*Y/t)    !  Z
             zi1o=zi1o+zia*exp(-vs*Y/t)     !  <I_z>
             zy1o=zy1o+da*Y*exp(-vs*Y/t)    !  <Y>   
            end do                ! Sabor
         end do                   ! Sabor
         
        dmea=dmea+dmeao*(nds(l,ha(1),ha(2),ha(3),ha(4),ha(5))+1)
     &    *mult(l,ha(1),ha(2),ha(3),ha(4),ha(5))  !(hu2a1(l)-hu2a2(l)+1)   ! Spin       
        zi1=zi1+zi1o*(nds(l,ha(1),ha(2),ha(3),ha(4),ha(5))+1)
     &    *mult(l,ha(1),ha(2),ha(3),ha(4),ha(5))  !(hu2a1(l)-hu2a2(l)+1)   ! Spin       
        zy1=zy1+zy1o*(nds(l,ha(1),ha(2),ha(3),ha(4),ha(5))+1)
     &    *mult(l,ha(1),ha(2),ha(3),ha(4),ha(5))  !(hu2a1(l)-hu2a2(l)+1)   ! Spin       
      end do                                      ! nrb
C------------ quarks

      dmeb=0.0
      zy2=0.0
      zi2=0.0
      do l=1,ir(hb(1),hb(2),hb(3),hb(4),hb(5))  !nrb
 
         lam=lamb(l,hb(1),hb(2),hb(3),hb(4),hb(5))!(hu3b1(l)-hu3b2(l))
         mu=mub(l,hb(1),hb(2),hb(3),hb(4),hb(5))!(hu3b2(l)-hu3b3(l))
         dmebo=0.0
         zi2o=0.0
         zy2o=0.0
         do np=0,lam
            do nq=0,mu
               db=0.0
               zyb=0.0             
               zib=0.0
               Y= -(2.0*lam+mu-3.0*(np+nq))/3.0
               tI=(mu+np-nq)/2.0                           
             do tiz=-tI,tI
              db=db+exp((vIz*tIz)/t)
              zib=zib+tiz*exp((vIz*tIz)/t)
             end do              

              dmebo=dmebo+db*exp(-vs*Y/t)    !  Z
              zi2o=zi2o+zib*exp(-vs*Y/t)     !  <I_z>
              zy2o=zy2o+db*Y*exp(-vs*Y/t)    !  <Y>
            end do
         end do   
         
        dmeb=dmeb+dmebo*(nds(l,hb(1),hb(2),hb(3),hb(4),hb(5))+1)
     &    *mult(l,hb(1),hb(2),hb(3),hb(4),hb(5)) !(hu2b1(l)-hu2b2(l)+1)   ! Spin  
        zi2=zi2+zi2o*(nds(l,hb(1),hb(2),hb(3),hb(4),hb(5))+1)
     &    *mult(l,hb(1),hb(2),hb(3),hb(4),hb(5))! (hu2b1(l)-hu2b2(l)+1)   ! Spin       
        zy2=zy2+zy2o*(nds(l,hb(1),hb(2),hb(3),hb(4),hb(5))+1)
     &    *mult(l,hb(1),hb(2),hb(3),hb(4),hb(5))!(hu2b1(l)-hu2b2(l)+1)   ! Spin       
      end do   
 
c----------------
      dme=dmea*dmeb
      zi1=zi1*dmeb
      zi2=dmea*zi2
      zy1=zy1*dmeb
      zy2=dmea*zy2
c*************************************************


c****DIMENSION DE COLOR
           du3=0.5*(nh1t-nh2t+1)*(nh2t-nh3t+1)*(nh1t-nh3t+2)  
c****POTENCIAL QUIMICO
           fmu=exp((vB+vS)*numBar/t)!exp(-v*ndomega/t)

                vcolor=vcolor+( (nh1t-nh2t)**2+(nh1t-nh2t)*(nh2t-nh3t)
     &          +(nh2t-nh3t)**2+3*(nh1t-nh3t) )*du3*dme*zz(ndjef)*fmu  
               vcolcu=vcolcu+(( (nh1t-nh2t)**2+(nh1t-nh2t)*(nh2t-nh3t)
     &        +(nh2t-nh3t)**2+3*(nh1t-nh3t) )**2)*du3*dme*zz(ndjef)*fmu
                Z    =    Z+du3*dme*fmu*zz(ndjef)
                vbar = vbar+du3*dme*fmu*zz(ndjef)*numbar  
                vY1  =  vY1+du3*zy1*fmu*zz(ndjef)
                vy2  =  vy2+du3*zy2*fmu*zz(ndjef)
                vybo = vybo+du3*dme*fmu*vyb(ndjef)
                vi1  = vi1 +du3*zi1*fmu*zz(ndjef)
                vi2  = vi2 +du3*zi2*fmu*zz(ndjef)
                vibo = vibo+du3*dme*fmu*vib(ndjef)
                vexe = vexe+du3*dme*fmu*vez(ndjef)
                vexec=vexec+du3*dme*fmu*veez(ndjef) 
                vexpfer=vexpfer+du3*dme*fmu*vpf(ndjef)   
                vexpglu=vexpglu+du3*dme*fmu*vpg(ndjef)      
                vexqu= vexqu+du3*dme*fmu*zz(ndjef)*numq
                vexqub= vexqub+du3*dme*fmu*zz(ndjef)*numqb  
         end do   ! h3t
         end do   ! h2t
         end do   ! h1t  
            
C TEMP,MU,<E>, C         

      deltmp=-0.238
      tetap=-23.7*2*3.1415/360.0
      hachtp=0.15

      deltmv=-0.0833
      tetav=0.61548
      hachtv=-0.0565685
c -----------------------etj(n,S,lam,mu,par,ndj)--------------------

c----------- G-M-O -----------------------------------
        hcc1p=(1.0+deltmp/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &               (1.0*(1.0+1.0)-0.0**2/4.0))  ! Pion
        hcc2p=(1.0+deltmp/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &               (0.5*(0.5+1.0)-1.0**2/4.0))  ! Kaon
        hcc3p=(1.0+deltmp/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &               (0.0*(0.0+1.0)-0.0**2/4.0))  ! Singlett


        hcc1v=(1.0+deltmv/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &               (1.0*(1.0+1.0)-0.0**2/4.0))  ! Pion
        hcc2v=(1.0+deltmv/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &               (0.5*(0.5+1.0)-1.0**2/4.0))  ! Kaon
        hcc3v=(1.0+deltmv/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &               (0.0*(0.0+1.0)-0.0**2/4.0))  ! Singlett
c-----------------------------------------------------

        zjf0s=exp(-(1/t)*
     &       (etj(2,0,0,0,0,18)-etj(1,0,0,0,0,18)))  ! Sigma

        zjf1p=exp(-(1/t)*
     &         (hcc1p*(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))))
     &                 *exp(viz/T)! Pion^+ 

        zjf1n=exp(-(1/t)*
     &         (hcc1p*(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))))
     &                 *exp(-viz/T)! Pion^-
   
        zjf2s=exp(-(1/t)*
     &        (hcc2p*(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))))
     &          *exp(vs/t)*exp(viz/(2.0*T))            ! K+

        zjf3s=exp(-(1/t)*
     &        (hcc2p*(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))))
     &          *exp(-vs/t)*exp(-viz/(2.0*T))           ! K-  

        zjf4s=exp(-(1/t)*
     &        (etj(1,0,1,1,0,18)-etj(1,0,0,0,0,18))) ! f0 

        zjf5s=exp(-(1/t)*
     &        (hcc2v*(etj(1,1,1,1,1,18)-etj(1,0,0,0,0,18))))
     &          *exp(vs/t)            ! K*+

        zjf6s=exp(-(1/t)*
     &        (hcc2v*(etj(1,1,1,1,1,18)-etj(1,0,0,0,0,18))))
     &          *exp(-vs/t)           ! K*-  
        zjf7s=exp(-(1/t)*
     &        (hcc3v*(etj(1,1,0,0,1,18)-etj(1,0,0,0,0,18))))
     &                                ! Phi 
c---------------------------------------------------------

c      Verhaeltnis <K+>/<Pi+>
c         verh4=zjf3s/zjf1s

c-------------------------------------------------------
c IMPORTANTE!!!!!! ENERGIA RESPECTO AL VACIO
         energia=VEXE/Z + 1.0*etj(1,0,0,0,0,18)
         energy=VEXE/Z 
         calor=(1.0/T**2)*(VEXEC/Z-(VEXE/Z)**2)
         barion=vbar/Z
         thyp=(vy1+vy2+vybo)/Z
         tIsoz=(vi1+vi2+vibo)/Z
         strange=thyp-barion
         carga=tisoz+thyp/2
         color=   vcolor/Z
         entropia=((energia-1.0*etj(1,0,0,0,0,18))
     &       +t*log(z)-vb*barion-vs*strange)/t
         delcol=sqrt( (vcolcu/Z)-color**2 )
         quarks=(vexqu+(vexpfer/2.0))/Z
         aquarks=(vexqub+(vexpfer/2.0))/Z
         gluons=vexpglu/(2.0*Z)+zngb
	 presV=T*Log(Z)		 
c---------------------
        
         if (itest.eq.0) then 
            voln=8.0**3*4.18879
         end if
         radel=1.0
c         do radel=0.3,1.1,0.01
         if (itest.eq.1) then                       
            voln=(numpart/barion)* (radel)**3*4.18879         
         end if

         radius=(voln*0.238732)**(1.0/3.0)

         verh0=zjf0s/z*(voln/(4.18879*radel**3))  ! Sigma 
         verh1=(zjf1p/z)*(voln/(4.18879*radel**3))! <Pionen^+>
         verh2=(zjf2s/z)*(voln/(4.18879*radel**3))! <K+>
         verh3=(zjf3s/z)*(voln/(4.18879*radel**3))! <K->
         verh4=verh3/verh2
         verh5=(zjf5s)/z*(voln/(4.18879*0.4**3))!         
c         verh4=zjf4s/z*(voln/(4.18879*0.55**3))! f0   0^+ Oktett  
c         verh5=zjf5s/z*(voln/(4.18879*0.55**3))! Vektor-Mesonen 1
c----------------------------------------------------------------
c    escriba para Color total             
       if (kktest.eq.1) then
c                      1    2      3      4      5     6      7      8
       if (ntest.eq.0) then
       if (energia.eq.energia)       !write(*,234) 
     &    WRITE(10,*) T,presV,energia,calor,color,delcol!,barion,entropia,carga
       end if
       if (ntest.eq.1) then
         WRITE(11,*)  T,verh1,verh2,verh3,energy*voln,barion
         WRITE(13,*)  T,radius,barion,entropia/barion,entropia
       end if
       if(ifit0.eq.0) then
          WRITE(29,*)   T,quarks,aquarks,gluons
       end if   
       end if
c-----------------------------------------------------------------
c    escriba para Color (0,0)            
       if (kktest.eq.0) then
c                      1    2      3      4      5     6      7      8
       if (ntest.eq.0) then
       if (energia.eq.energia)       !write(*,234) 
     &    WRITE(20,*) T,presV,energia,calor,barion,entropia,carga
       end if
       if (ntest.eq.1) then
         WRITE(22,*)  T,verh1,verh2,verh3,energy*voln,barion
         WRITE(26,*)  T,radius,barion,entropia/barion,entropia
       end if
       if(ifit0.eq.0) then
          WRITE(30,*)   T,vb,vs,quarks,aquarks,gluons
       end if   
       end if

        end do !!  kktest
        END DO !(temperatura)
c      END DO  !(potencial quimico)

 234  format (2(1x,f10.6),1x,f10.6,3(1x,f10.6))
 300  return
      end

c---------------------------------------------------------------------

      subroutine part(zj,vib,vyb,vee,veec,t,ndj,etj,ndtj,ktest,
     &                numeig,neigw,smax,ndomega,vb,vs,viz,lamax,zgb,
     &                xpf,xpg,vf,vg)
      implicit real*8(a-H,O-Z)
      integer smax
c      parameter(lamax=4)
      dimension  etj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension  xpf(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension  xpg(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      integer ndtj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension numeig(0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      
      zj=0.0
      vee=0.0
      veec=0.0
      vib=0.0
      vyb=0.0
      vf=0.0
      vg=0.0

      deltmp=-0.238
      tetap=-23.7*2*3.1415/360.0
      hachtp=0.15

      deltmv=-0.0833
      tetav=0.61548
      hachtv=-0.0565685

    
      do npar=0,1        ! Paridad
        do nla=0,lamax       ! Sabor lambda
           do nmu=0,lamax    ! Sabor mu
          lam=nla
          mu=nmu
          vfi=0.0
          vfy=0.0
          ffl=0.0
          do np=0,lam    ! Sabor p 
            do nq=0,mu   ! Sabor q
               d=0.0                            
               vi=0.0
               Y=-(2.0*lam+mu-3.0*(np+nq))/3.0
               TI=(mu+np-nq)/2.0                           
             do tiz=-TI,TI  ! Sabor isoespin_Z
              d=d+exp((vIz*tIz)/t)
              vi=vi+tiz*exp((vIz*tIz)/t)
             end do         ! Sabor isoespin_Z
c              write(*,*) vi
             ffl=d*exp(vs*Y/t)      ! ffl+   Z
             vfi=vi*exp(vs*Y/t)     ! vfi+  <I_z>
             vfy=d*Y*exp(vs*Y/t)    ! vfy+  <Y>
c            end do       ! Sabor q      
c          end do         ! Sabor p
          do ns=0,smax                            ! Spin
             do nraiz=1,numeig(ns,nla,nmu,npar,ndj)    ! Eigenvalores
               fd=1.0*ndtj(nraiz,ns,nla,nmu,npar,ndj) !DEGENERACION
     &               *(2*ns+1)                     !SPIN
ccc     &              0.5*(nla+1)*(nla+1)*(nla+nmu+2)  !FLAVOUR
            hcc=1.0   
cGELL-MANN OKUBO FORMULA!!!!!!!!!!

          if (ktest.eq.1) then
           if ((nraiz.eq.1).and.(ns.eq.0).and.(nla.eq.1).and.
     &      (npar.eq.1).and.(ndj.eq.18).and.(nmu.eq.1)) then! Pion-Oktett
            hcc=(1.0+deltmp/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &                      (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtp*tan(tetap)) 
            else if ((nraiz.eq.1).and.(ns.eq.1).and.(nla.eq.1).and.
     &      (npar.eq.1).and.(ndj.eq.18).and.(nmu.eq.1) ) then   ! Rho-Oktett
               hcc=(1.0+deltmv/(etj(1,1,1,1,1,18)-etj(1,0,0,0,0,18))*
     &                     (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtv*tan(tetav))
            else if ((nraiz.eq.1).and.(ns.eq.0).and.(nla.eq.0).and.
     &      (npar.eq.1).and.(ndj.eq.18).and.(nla.eq.0)) then! Eta'-Singlett
               hcc=(1.0+deltmp/(etj(1,0,0,0,1,18)-etj(1,0,0,0,0,18))*
     &                    (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtp*tan(tetap)) 
            else if ((nraiz.eq.1).and.(ns.eq.1).and.(nla.eq.0).and.
     &      (npar.eq.1).and.(ndj.eq.18).and. (nla.eq.0)) then! Phi-Singlett
               hcc=(1.0+deltmv/(etj(1,1,0,0,1,18)-etj(1,0,0,0,0,18))*
     &                     (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtv*tan(tetav)) 
            end if
          end if

c FIN DE G-M-O
c          if ((nraiz.eq.1).and.(ns.eq.0).and.(nla.eq.0).and.
c     &        (nmu.eq.0).and.(npar.eq.0).and.(ndj.eq.18)) then 
c             goto 678
c          end if   
            zj=zj+zgb*fd*ffl*exp(-(1/t)*hcc*
     &    (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )  !Z


            vib=vib+zgb*fd*vfi*exp(-(1/t)*hcc*
     &     (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )  !<I_z>

            vyb=vyb+zgb*fd*vfy*exp(-(1/t)*hcc*
     &    (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )  !<Y>

            vee=vee+zgb*fd*ffl*hcc*
     &     (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18) )* !<E>
     &      exp(-(1/t)*hcc*
     &      (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) ) 

            veec=veec+zgb*fd*ffl*((hcc*
     &   (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )**2)*  !<E^2>
     &     exp(-(1/t)*hcc*(
     &     etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18))) 

            vf=vf+zgb*fd*ffl*hcc*
     &     (xpf(nraiz,ns,nla,nmu,npar,ndj) )* !<Npf>
     &      exp(-(1/t)*hcc*
     &      (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) ) 

            vg=vg+zgb*fd*ffl*hcc*
     &     (xpg(nraiz,ns,nla,nmu,npar,ndj) )* !<Npf>
     &      exp(-(1/t)*hcc*
     &      (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )


c 678        continue
             end do     ! Eigenvalores 
           end do       ! Spin
            end do       ! Sabor q      
          end do         ! Sabor p
        end do           !Sabor mu
        end do           ! Sabor lamabda
      end do             ! Paridad
  
      return 
      end

      function dimu6(h1,h2,h3,h4,h5,h6)
       integer dimu6,h1,h2,h3,h4,h5,h6
       dimu6=( (h1-h2+1)*(h1-h3+2)*(h1-h4+3)*(h1-h5+4)*(h1-h6+5)
     &*(h2-h3+1)*(h2-h4+2)*(h2-h5+3)*(h2-h6+4)*(h3-h4+1)*(h3-h5+2)
     &*(h3-h6+3)*(h4-h5+1)*(h4-h6+2)*(h5-h6+1) )
     &  / (5*4*3*2*4*3*2*3*2*2) 

        end


